/*================================================================*/
/* COPYRIGHT:                                                     */
/* ----------                                                     */
/* Copyright (C) International Business Machines Corp., 1996.     */
/*                                                                */
/* DISCLAIMER OF WARRANTIES:                                      */
/* -------------------------                                      */
/* The following [enclosed] code is sample code created by IBM    */
/* Corporation.  This sample code is not part of any standard IBM */
/* product and is provided to you solely for the purpose of       */
/* assisting you in the development of your applications.  The    */
/* code is provided "AS IS", without warranty of any kind.  IBM   */
/* shall not be liable for any damages arising out of your use of */
/* the sample code, even if they have been advised of the         */
/* possibility of such damages.                                   */
/*================================================================*/

#ifndef AUDSAMPL_H
#define AUDSAMPL_H


#define AUDIO_BIG_ENDIAN     ( 1 )
#define AUDIO_LITTLE_ENDIAN  ( 2 )

#define BLOCK_HEADER_SIZE           ( 26 )
#define BLOCK_DATA_SIZE             ( 1024 )
#define BLOCK_TOTAL_SIZE            ( BLOCK_HEADER_SIZE + BLOCK_DATA_SIZE )

#define HEADER_OFFSET_BYTE_ORDER   0  /* Offset... byte order identifier  */
#define HEADER_OFFSET_FORMAT       1  /*           uncompressed/compressed*/
#define HEADER_OFFSET_SAMPLES      2  /*           complete samples/block */
#define HEADER_OFFSET_VOLUME       3  /*           block volume           */
#define HEADER_OFFSET_ONE          4  /*           Eddie's "1"            */
#define HEADER_OFFSET_BLOCK_INDEX  5  /*           running block index    */
#define HEADER_OFFSET_END_OF_PCM   6  /*           last block mark        */
#define HEADER_OFFSET_PCM_LENGTH  11  /*           pcm bytes per block    */
#define HEADER_OFFSET_DATA_LENGTH 12  /*           data bytes per block   */

#ifdef DEBUG
#define DebugMsg(s)                       \
        OutputDebugString(s);             \
        fprintf ( the_log_file, s );      \
        fflush ( the_log_file );
#else
#define DebugMsg(s)
#endif

#define ErrorMsg(s)                       \
        fprintf ( the_log_file, s );      \
        fflush ( the_log_file );


#define LogMsg(s)                         \
        if ( the_log_level > 0 )          \
        {                                 \
          fprintf ( the_log_file, s );    \
          fflush ( the_log_file );        \
        }


#endif
