//------------------------------------------------------------------------------
//
// COPYRIGHT:
// ----------
// Copyright (C) International Business Machines Corp., 1996.
//
// DISCLAIMER OF WARRANTIES:
// -------------------------
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM
// product and is provided to you solely for the purpose of
// assisting you in the development of your applications.  The
// code is provided "AS IS", without warranty of any kind.  IBM
// shall not be liable for any damages arising out of your use of
// the sample code, even if they have been advised of the
// possibility of such damages.
//
//------------------------------------------------------------------------------
// chkDlg.h : header file
//

#include "vtproxy.h"

/////////////////////////////////////////////////////////////////////////////
// CChkDlg dialog

class CChkDlg : public CDialog
{
// Construction
public:
	CChkDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CChkDlg)
	enum { IDD = IDD_CHK_DIALOG };
	CButton	m_mike;
	CEdit	m_user_prompt;
	CEdit	m_payto;
	CEdit	m_notes;
	CEdit	m_for;
	CEdit	m_date;
	CEdit	m_amount_text;
	CEdit	m_amount;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChkDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CChkDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSetfocusFor();
	afx_msg void OnKillfocusFor();
	afx_msg void OnSetfocusDate();
	afx_msg void OnKillfocusDate();
	afx_msg void OnSetfocusPayto();
	afx_msg void OnKillfocusPayto();
	afx_msg void OnSetfocusNotes();
	afx_msg void OnKillfocusNotes();
	afx_msg void OnSetfocusAmountText();
	afx_msg void OnKillfocusAmountText();
	afx_msg void OnMike();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
   VTProxy voicetype;
   void promptLine( const char * line );
   void doCommand( long command );
   void doDollarAnnotations( const char * dollarAnnotations );
   void displayDictatedWords( void );

   //support for loading language specific files //
   enum Tips 
        { TipOnDate, TipOnPayTo, TipOnAmount, TipOnFor, TipOnNotes, NumOfTips };
   char apchTips[ NumOfTips][256];			// tip list
   int	loadByLanguage();
   void	giveTip( Tips tip);
   int	loadTipFile( char * pchFileName);
   void loadDefaultTips();
   char* makeLangSpecificFile( char * pchFile,
                               const char * pchDir, const char * pchTempl, 
                               const char *pchLang, const char * pchExt);

   CEdit * m_pCurrentDictCtrl;
   CEdit * m_pCurrentGramCtrl;

};
