//------------------------------------------------------------------------------
//
// COPYRIGHT:
// ----------
// Copyright (C) International Business Machines Corp., 1996.
//
// DISCLAIMER OF WARRANTIES:
// -------------------------
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM
// product and is provided to you solely for the purpose of
// assisting you in the development of your applications.  The
// code is provided "AS IS", without warranty of any kind.  IBM
// shall not be liable for any damages arising out of your use of
// the sample code, even if they have been advised of the
// possibility of such damages.
//
//------------------------------------------------------------------------------
//
//  erecodlg.cpp - Implements methods of the eRecoDlg and class.
//              This is a Windows dialog class. The dialog instantiates a 
//              VTProxy object which is used for all communications with
//              the speech engine. It is the VTProxy class which implements
//              the calls to SMAPI functions.  
//
//              Also defines the CAboutDlg class and implements
//              it's methods. 
//
//------------------------------------------------------------------------------

#include "stdafx.h"
#include "eReco.h"
#include "eRecoDlg.h"
#include "gramSel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//------------------------------------------------------------------------------
//  CERecoDlg()
//------------------------------------------------------------------------------
//
//  MFC Generated Constructor for the CERecoDlg Windows dialog.
//
//------------------------------------------------------------------------------
CERecoDlg::CERecoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CERecoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CERecoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


//------------------------------------------------------------------------------
//  ~CERecoDlg()
//------------------------------------------------------------------------------
//
//  
//
//------------------------------------------------------------------------------
CERecoDlg::~CERecoDlg()
{
   int i;
   void *ptr;

   for (i = 0; i < m_listGrammarDescriptors.GetSize(); i++ )
   {
      ptr = m_listGrammarDescriptors.GetAt(i);
      delete (GrammarDescriptor *) ptr;
   }

   m_listGrammarDescriptors.RemoveAll();
}

//------------------------------------------------------------------------------
//  DoDataExchange()
//------------------------------------------------------------------------------
//
//  MFC Generated Windows data exchange method.
//
//------------------------------------------------------------------------------
void CERecoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CERecoDlg)
	DDX_Control(pDX, IDC_BUTTON_ENABLE_DISABLE, m_buttonEnableDisable);
	DDX_Control(pDX, IDC_BUTTON_START_STOP, m_buttonStartStop);
	DDX_Control(pDX, IDC_BUTTON_SELECT, m_buttonSelect);
	DDX_Control(pDX, IDC_USER_MESSAGES, m_listMessages);
	DDX_Control(pDX, IDC_GRAMMAR_LIST, m_listGrammar);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CERecoDlg, CDialog)
	//{{AFX_MSG_MAP(CERecoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SELECT, OnButtonSelect)
	ON_BN_CLICKED(IDC_BUTTON_START_STOP, OnButtonStartStop)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE_DISABLE, OnButtonEnableDisable)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//------------------------------------------------------------------------------
//  OnInitDialog()
//------------------------------------------------------------------------------
//
//  Window dialog initilization.
//
//------------------------------------------------------------------------------
BOOL CERecoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

   // IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// connect to the speech engine
   m_pxySMAPI.connect("ereco", m_hWnd, MY_CONNECTION_ID, FALSE);
   DisplayMessage( m_pxySMAPI.getMessage() );
   DisplayMessage( "Please select a grammar" );

   // disable buttons that cannot be used until a grammar/vocabulary
   // is selected
   m_buttonStartStop.EnableWindow(FALSE);
   m_buttonEnableDisable.EnableWindow(FALSE);
	
   // set the scroll bar for the message box
   m_listMessages.SetHorizontalExtent(1000);

	return TRUE;  // return TRUE  unless you set the focus to a
                 // control
}


//------------------------------------------------------------------------------
//  OnSystemCommand()
//------------------------------------------------------------------------------
//
//  MFC Generated Method to handle system messages.
//
//------------------------------------------------------------------------------
void CERecoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


//------------------------------------------------------------------------------
//  OnPaint()
//------------------------------------------------------------------------------
//
//  MFC Generated method for the CERecoDlg Windows dialog class.
//  If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
//
//------------------------------------------------------------------------------
void CERecoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//------------------------------------------------------------------------------
//  OnQueryDragIcon()
//------------------------------------------------------------------------------
//
//  MFC Generated method for the CERecoDlg Windows dialog class.
//  The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
//
//------------------------------------------------------------------------------
HCURSOR CERecoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//------------------------------------------------------------------------------
//  OnQueryDragIcon()
//------------------------------------------------------------------------------
//
//  The user has pushed the "select" button present a grammar/vocabulary 
//  selection dialog.
//
//------------------------------------------------------------------------------
void CERecoDlg::OnButtonSelect() 
{

   // create a grammar selection dialog object and start
   // the dialog
	GrammarSelect  selectionDialog(m_pxySMAPI,
                                  m_listGrammarDescriptors);
	int nResponse = selectionDialog.DoModal();

   if (nResponse == IDOK)
	{
		//  handle when the dialog is dismissed with OK

      // determine if any grammar/vocabulary selections have changed
      for (int i=0; i < m_listGrammarDescriptors.GetSize(); i++) {		
         GrammarDescriptor *theGrammar = (GrammarDescriptor *)
            m_listGrammarDescriptors.GetAt(i);
         if ( theGrammar->stateChange() )
         {
            // ungray the load button when we find a stateChange 
            // for the grammar
            m_buttonEnableDisable.EnableWindow(TRUE);
         }   		
         if ( theGrammar->selected() )
         {
            DisplayGrammar( (GrammarDescriptor *)
               m_listGrammarDescriptors.GetAt(i) );
         }
    }
	
	}
	else if (nResponse == IDCANCEL)
	{
		// handle when the dialog is dismissed with Cancel

   }

   // display the list of selected grammar(s)/vocabulary(ies)
   ShowGrammarList();

   // display any messages issued by m_pxySMAPI
   if (m_pxySMAPI.isMessageWaiting() )
   {
      DisplayMessage( m_pxySMAPI.getMessage() );  
   }
   
}


//------------------------------------------------------------------------------
//  OnCommand()
//------------------------------------------------------------------------------
//
//  Process messages for this dialog. All messages from the speech engine are 
//  passed to the smapi proxy (VTProxy) class. 
//
//------------------------------------------------------------------------------
BOOL CERecoDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	
   // these are message for me
   if (LOWORD(wParam) == MY_CONNECTION_ID)
   {
      int rc = m_pxySMAPI.engineMessage(lParam);
      if ( m_pxySMAPI.isMessageWaiting() )
      {
         DisplayMessage( m_pxySMAPI.getMessage() );
      }
      return rc;
   }
   else if (LOWORD(wParam) == ID_HELP)
   {
      MessageBox( "No Help available for this program" );
      return TRUE;
   }


	return CDialog::OnCommand(wParam, lParam);
}

//------------------------------------------------------------------------------
//  OnButtonEnableDisable()
//------------------------------------------------------------------------------
//
//  Processing for when the "EnableDisable Grammar" button is pushed
//
//------------------------------------------------------------------------------
void CERecoDlg::OnButtonEnableDisable() 
{

   BOOL   rc;
   BOOL   somethingActive = FALSE;
   BOOL   enabled;

   // Enable all selected grammar/vocabularies and
   // disable all that are not selected
   for (int i=0; i < m_listGrammarDescriptors.GetSize(); i++) {
      
      GrammarDescriptor *theGrammar = 			
         (GrammarDescriptor *)m_listGrammarDescriptors.GetAt(i);
      
      if ( theGrammar->selected() )
      {
         somethingActive = TRUE;
      }

      if( theGrammar->stateChange() )
      {		   
         theGrammar->acknowledgeStateChange();
    
         // is the vocabulary already enabled??
         enabled = m_pxySMAPI.isVocabEnabled(
                             theGrammar->vocabularyName() );
         if (m_pxySMAPI.isMessageWaiting() )
         {
            DisplayMessage( m_pxySMAPI.getMessage() );  
         }
      
         if ( theGrammar->selected() )
         {
            if (!enabled)
            {
               // Now enable the grammar/vocabulary
               rc = m_pxySMAPI.enableVocabulary(theGrammar->vocabularyName());
               if (m_pxySMAPI.isMessageWaiting() )
               {
                  DisplayMessage( m_pxySMAPI.getMessage() );  
               }
               if ( rc )				
               {
                  DisplayMessage("*** Grammar <%s> enabled ***", 	 
                     theGrammar->fsgFileName() );
               }  
            }
         }
         else
         {
            if (enabled)
            {
               // disable the grammar/vocabulary	
               rc = m_pxySMAPI.disableGrammar(theGrammar->vocabularyName());
               if (m_pxySMAPI.isMessageWaiting() )
               {
                  DisplayMessage( m_pxySMAPI.getMessage() );  
               }
       
               if ( rc )				
               {
                  DisplayMessage("*** Grammar <%s> disabled ***", 	 
                     theGrammar->fsgFileName() );
             
               }
            }
         }
      }
   }

   // enable and disable window buttons 
   if ( somethingActive ) 
   {
      // at least 1 vocabulary is active - can't reco
      m_buttonStartStop.EnableWindow(TRUE); 
   } 
   else
   {
      // no vocabulary is active - allow reco
      m_buttonStartStop.EnableWindow(FALSE);  
   }
   m_buttonEnableDisable.EnableWindow(FALSE);

}


//------------------------------------------------------------------------
// OnButtonStartStop()
//------------------------------------------------------------------------
// If already recognizing, turns off the microphone and stops the
// recognition process, else, turns on the microphone and starts the
// recognition process.
//------------------------------------------------------------------------
void CERecoDlg::OnButtonStartStop() 
{

   if ( m_pxySMAPI.recognizing() )
   {
      m_pxySMAPI.stopRecognizing();
      if ( m_pxySMAPI.isMessageWaiting() )   
      {
         DisplayMessage( m_pxySMAPI.getMessage() );
      }

      m_buttonStartStop.SetWindowText("Start &Recognizing");
   }
   else
   { 
      if ( m_pxySMAPI.startRecognizing() )
      {  
         DisplayMessage("Recognition started, microphone turned on.");
         m_buttonStartStop.SetWindowText("Stop &Recognizing");
         
      } 
      if ( m_pxySMAPI.isMessageWaiting() )   
      {
         DisplayMessage( m_pxySMAPI.getMessage() );
      }
   }
   
}
	

//------------------------------------------------------------------------
// OnCancel()
//------------------------------------------------------------------------
// Clean up when the cancel button is pushed... this includes 
// disconnecting from the speech engine
//------------------------------------------------------------------------
void CERecoDlg::OnCancel() 
{
	
   // Close the connection to the recognition engine.
   long rc = m_pxySMAPI.disconnect();

   if (rc != SM_RC_OK)
   {   
      CString szMsg;
      szMsg.Format("Unable to close connection to engine, rc=%d (%s)", rc,
         SmReturnRcDescription(rc));   
      AfxMessageBox(szMsg);
   }
   
	CDialog::OnCancel();
}

//------------------------------------------------------------------------
// ShowGrammarList()
//------------------------------------------------------------------------
// Display all selected grammar/vocabularies in the  
// "selected grammar/vocabulary" listbox
//------------------------------------------------------------------------
void CERecoDlg::ShowGrammarList() 
{
   BOOL  somethingSelected=FALSE;

   m_listGrammar.ResetContent();    // reinit the ListBox
   
   // display those grammars that are currently selected
   // for speech recognition
   for (int i=0; i < m_listGrammarDescriptors.GetSize(); i++) {
		
      GrammarDescriptor *theGrammar = (GrammarDescriptor *)
         m_listGrammarDescriptors.GetAt(i);

      if ( theGrammar->selected() )
      {

         DisplayGrammar( (GrammarDescriptor *)
                          m_listGrammarDescriptors.GetAt(i) );

      }
   		
   }

   return;

}


//------------------------------------------------------------------------
// DisplayGrammar()
//------------------------------------------------------------------------
// Display a single grammar/vocabulary in the listbox
//------------------------------------------------------------------------
void CERecoDlg::DisplayGrammar(GrammarDescriptor *theGrammar)
{

   m_listGrammar.InsertString(0, theGrammar->fsgFileName() ); 

}


//------------------------------------------------------------------------------
//  DisplayMessage()
//------------------------------------------------------------------------------
//
//  Display any messages in the messages list box. Uses printf style formatting
//  of variable length argument lists.
//
//------------------------------------------------------------------------------
void CERecoDlg::DisplayMessage(const char* pszFormat, ...)
{
        va_list vaArgList;
	     char    szMessage[256];

        va_start(vaArgList, pszFormat);
        vsprintf(szMessage, pszFormat, vaArgList);
        va_end(vaArgList);

        int rc = m_listMessages.SetCurSel(m_listMessages.AddString(szMessage));
}


