//------------------------------------------------------------------------------
//
//    COPYRIGHT:
//    ----------
//    Copyright (C) International Business Machines Corp., 1996.
//
//      DISCLAIMER OF WARRANTIES:
//      -------------------------
//      The following [enclosed] code is sample code created by IBM
//      Corporation.  This sample code is not part of any standard IBM
//      product and is provided to you solely for the purpose of
//      assisting you in the development of your applications.  The
//      code is provided "AS IS", without warranty of any kind.  IBM
//      shall not be liable for any damages arising out of your use of
//      the sample code, even if they have been advised of the
//      possibility of such damages.
//
//------------------------------------------------------------------------------
//
//  erecodlg.h - Declares the methods and attibutes of CERecoDlg class.  
//
//------------------------------------------------------------------------------
#include "vtproxy.h"
#include "gramDesc.h"

class CERecoDlg : public CDialog
{

public:
	CERecoDlg(CWnd* pParent = NULL);	// standard constructor
   ~CERecoDlg();

   // Dialog Data
	//{{AFX_DATA(CERecoDlg)
	enum { IDD = IDD_ERECO_DIALOG };
	CButton	m_buttonEnableDisable;
	CButton	m_buttonStartStop;
	CButton	m_buttonSelect;
	CListBox	m_listMessages;
	CListBox	m_listGrammar;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CERecoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CERecoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonSelect();
	afx_msg void OnButtonStartStop();
	virtual void OnCancel();
	afx_msg void OnButtonEnableDisable();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	 // methods
    void DisplayMessage(const char* pszFormat, ...);
    void ShowGrammarList();
    void DisplayGrammar(GrammarDescriptor *theGrammar);

    // attributes
    CPtrArray  m_listGrammarDescriptors;
    VTProxy    m_pxySMAPI;
};

// Additional useful constants, etc.
#define MY_CONNECTION_ID                                0xFAB4
