/******************************************************************************/
/*                                                                            */
/* COPYRIGHT:                                                                 */
/* ----------                                                                 */
/* Copyright (C) International Business Machines Corp., 1996.                 */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/* -------------------------                                                  */
/* The following [enclosed] code is sample code created by IBM                */
/* Corporation.  This sample code is not part of any standard IBM product     */
/* and is provided to you solely for the purpose of assisting you in the      */
/* development of your applications.  The code is provided "AS IS",           */
/* without warranty of any kind.  IBM shall not be liable for any damages     */
/* arising out of your use of the sample code, even if they have been         */
/* advised of the possibility of such damages.                                */
/*                                                                            */
/******************************************************************************/
// recoDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRecoDlg dialog

#include <smapi.h>

class CRecoDlg : public CDialog
{
// Construction
public:
        CRecoDlg(CWnd* pParent = NULL); // standard constructor

// Dialog Data
        //{{AFX_DATA(CRecoDlg)
        enum { IDD = IDD_RECO_DIALOG };
        CListBox        m_listStatus;
        CEdit   m_editFSG;
        CButton m_buttonStartReco;
        CButton m_buttonSelectFSG;
        CButton m_buttonLoadFSG;
        CString m_szFSG;
        CString m_phrase;
        //}}AFX_DATA

        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CRecoDlg)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support
        virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
        //}}AFX_VIRTUAL

// Implementation
protected:
        BOOL m_bEngineReady;                                    // Is the engine ready?
        HICON m_hIcon;
        char m_szActiveGrammar[_MAX_PATH];              // The currently active grammar file name
        char m_szActiveVocab[_MAX_PATH];                // The currently active vocabulary name
        BOOL m_bRecognizing;                                    // Indicates whether or not recognition is active

        // Generated message map functions
        //{{AFX_MSG(CRecoDlg)
        virtual BOOL OnInitDialog();
        afx_msg void OnButtonLoadFsg();
        afx_msg void OnButtonSelectFsg();
        afx_msg void OnButtonStartReco();
        virtual void OnCancel();
        afx_msg void OnUpdateEditFsgFile();
        afx_msg void OnActivateApp(BOOL bActive, HTASK hTask);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()

        // Additional functions
        long StartRecoEngine();
        long StopRecoEngine();
        BOOL ProcessEngineMessage(LPARAM lParam);
        int DisableGrammar();
        int EnableGrammar();
        int IsVocabDefined(BOOL* bResult);
        int StartRecognizing();
        int StopRecognizing();
        int BeginListening();
        int ProcessRecognizedPhrase(SM_MSG reply);
        int ProcessEngineError(SM_MSG reply, int rcEngine);
        void Display(const char* pszFormat, ...);

};

// Additional useful constants, etc.
#define MY_CONNECTION_ID                                0xFAB4
