//------------------------------------------------------------------------------
//
// COPYRIGHT:
// ----------
// Copyright (C) International Business Machines Corp., 1996.
//
// DISCLAIMER OF WARRANTIES:
// -------------------------
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM
// product and is provided to you solely for the purpose of
// assisting you in the development of your applications.  The
// code is provided "AS IS", without warranty of any kind.  IBM
// shall not be liable for any damages arising out of your use of
// the sample code, even if they have been advised of the
// possibility of such damages.
//
//------------------------------------------------------------------------------
// SmDpView.h : interface of the CSmDplusView class
//
/////////////////////////////////////////////////////////////////////////////

#include "vtproxy.h"                   // defines IBM ViaVoice proxy class
#include "vtdata.h"                    // defines a user data dialog
#include "vtdm.h"

class CSmDplusView : public CView
{
protected: // create from serialization only
	CSmDplusView();
	DECLARE_DYNCREATE(CSmDplusView)

	VTProxy voicetype;                  // object representing IBM ViaVoice
   CEdit mledit;                       // a multi-line edit control
   VTData vtdata;                      // a dialog which will show user data

// Attributes
public:
	CSmDplusDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSmDplusView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSmDplusView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

private:
   VTDictationMacroDatabase* m_macrodatabase;

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSmDplusView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnVoicetypeBegindictation();
	afx_msg void OnVoicetypeStopdictation();
	afx_msg void OnVoicetypeConnect();
	afx_msg void OnVoicetypeDisconnect();
	afx_msg void OnVoicetypeCorrectselection();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDlgVtdata();
	afx_msg void OnUpdateVoicetypeConnect(CCmdUI* pCmdUI);
	afx_msg void OnUpdateVoicetypeDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnUpdateVoicetypeBegindictation(CCmdUI* pCmdUI);
	afx_msg void OnUpdateVoicetypeStopdictation(CCmdUI* pCmdUI);
	afx_msg void OnUpdateVoicetypeCorrectselection(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppMacrolist(CCmdUI* pCmdUI);
	afx_msg void OnAppMacrolist();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SmDpView.cpp
inline CSmDplusDoc* CSmDplusView::GetDocument()
   { return (CSmDplusDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
