// ttsdictDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ttsdict.h"
#include "ttsdictDlg.h"
#include "font.h"	

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTtsdictDlg dialog

CTtsdictDlg::CTtsdictDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTtsdictDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTtsdictDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTtsdictDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTtsdictDlg)
	DDX_Control(pDX, IDC_VVTEXTBOX1, m_TextBox);
	DDX_Control(pDX, IDC_VVCTRL1, m_VirtualVoices);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTtsdictDlg, CDialog)
	//{{AFX_MSG_MAP(CTtsdictDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_READ, OnRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTtsdictDlg message handlers

BOOL CTtsdictDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// select language of the TTS engine,
        // here the language of the TTS engine is matched to the user locale
        // the modes used are the standard modes for the IBM ViaVoice Outloud TTS engine
	
   LCID lcid = ::GetUserDefaultLCID();
   LANGID lang       = LANGIDFROMLCID(lcid);
   WORD lang_primary = PRIMARYLANGID(lang);
   WORD lang_sub     = SUBLANGID(lang);
   CString szModeGuid;

   switch (lang_primary)
   {
      case LANG_JAPANESE:
		 if ( szModeGuid.IsEmpty() ) 
	         szModeGuid = "{904AAB60-5D94-11D0-830A-444553540000}";   
         break;
      case LANG_CHINESE:
		 if ( szModeGuid.IsEmpty() ) 
	         szModeGuid = "{BF5EAD40-9F65-11CF-8FC8-0020AF14F271}";
         break;
      case LANG_SPANISH:
		 if ( szModeGuid.IsEmpty() ) 
	         szModeGuid = "{BF5EAD67-9F65-11CF-8FC8-0020AF14F271}";
     break;
      case LANG_ITALIAN:
		 if ( szModeGuid.IsEmpty() )
	         szModeGuid = "{BF5EAD90-9F65-11CF-8FC8-0020AF14F271}";
         break;
      case LANG_FRENCH:
		 if ( szModeGuid.IsEmpty() ) 
	         szModeGuid = "{BF5EAD70-9F65-11CF-8FC8-0020AF14F271}";
         break;
      case LANG_GERMAN:
		 if ( szModeGuid.IsEmpty() ) 
	         szModeGuid = "{BF5EAD80-9F65-11CF-8FC8-0020AF14F271}";
         break;
      case LANG_ENGLISH:
		 if ( szModeGuid.IsEmpty() ) 
	         szModeGuid = "{BF5EAD40-9F65-11CF-8FC8-0020AF14F271}";
         if (lang_sub == SUBLANG_ENGLISH_UK)
         {
			 if ( szModeGuid.IsEmpty() ) 
	            szModeGuid = "{BF5EAD50-9F65-11CF-8FC8-0020AF14F271}";
         }
         break;
      default:
		 if ( szModeGuid.IsEmpty() ) 
	         szModeGuid = "{BF5EAD40-9F65-11CF-8FC8-0020AF14F271}";
         break;
   }
   m_VirtualVoices.SetModeGuid(szModeGuid);

   //Set default charset value to allow DBCS string.
   
   COleFont cof;
   cof = m_TextBox.GetFont();   
   cof.SetCharset(DEFAULT_CHARSET);
   m_TextBox.SetFont(cof.m_lpDispatch);   
 
  

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTtsdictDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTtsdictDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTtsdictDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTtsdictDlg::OnRead() 
{
   CString allText;
   short   selLength;

   selLength = m_TextBox.GetSelLength();

   if ( selLength == 0 )
      allText = m_TextBox.GetText();
   else
      allText = m_TextBox.GetSelText();

   if ( allText.IsEmpty() )
      m_VirtualVoices.SetSpeakText( "The text box is empty" );
   else
     m_VirtualVoices.SetSpeakText( allText );


   m_VirtualVoices.Speak();
 
}
